#pragma once

#include "CoreMinimal.h"
#include "CoreSelectableButtonWidget.h"
#include "StoreRiftTierViewData.h"
#include "CoreStoreRiftTierItemWidget.generated.h"

class UDBDImage;
class UDBDTextBlock;
class UCoreOnHoverBorderWidget;
class UCoreButtonWidget;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIVIEWSCORE_API UCoreStoreRiftTierItemWidget : public UCoreSelectableButtonWidget
{
	GENERATED_BODY()

protected:
	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDImage* IconIMG;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDTextBlock* AmountTB;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCoreOnHoverBorderWidget* OnHoverBorder;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient)
	FStoreRiftTierViewData _viewData;

public:
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent)
	void SetData(const FStoreRiftTierViewData& data);

protected:
	UFUNCTION(BlueprintCallable)
	void OnButtonUnhovered(UCoreButtonWidget* targetButton);

	UFUNCTION(BlueprintCallable)
	void OnButtonHovered(UCoreButtonWidget* targetButton);

public:
	UCoreStoreRiftTierItemWidget();
};

FORCEINLINE uint32 GetTypeHash(const UCoreStoreRiftTierItemWidget) { return 0; }
